> ## Documentation Index
> Fetch the complete documentation index at: https://www.c1.ai/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# List

> List all apps.



## OpenAPI

````yaml https://spec.speakeasy.com/conductor-one/conductorone/my-source-with-code-samples get /api/v1/apps
openapi: 3.1.0
info:
  description: The C1 API is a HTTP API for managing C1 resources.
  title: C1 API
  version: 0.1.0-alpha
servers:
  - description: The C1 API server for the current tenant.
    url: https://{tenantDomain}.conductor.one
    variables:
      tenantDomain:
        default: example
        description: The domain of the tenant to use for this request.
security:
  - bearerAuth: []
    oauth: []
paths:
  /api/v1/apps:
    get:
      tags:
        - App
      summary: List
      description: List all apps.
      operationId: c1.api.app.v1.Apps.List
      parameters:
        - in: query
          name: page_size
          schema:
            description: The pageSize field.
            format: int32
            readOnly: false
            type: integer
        - in: query
          name: page_token
          schema:
            description: The pageToken field.
            readOnly: false
            type: string
      responses:
        '200':
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/c1.api.app.v1.ListAppsResponse'
          description: >-
            The ListAppsResponse message contains a list of results and a
            nextPageToken if applicable.
      x-codeSamples:
        - lang: go
          label: List
          source: "package main\n\nimport(\n\t\"context\"\n\t\"github.com/conductorone/conductorone-sdk-go/pkg/models/shared\"\n\tconductoronesdkgo \"github.com/conductorone/conductorone-sdk-go\"\n\t\"github.com/conductorone/conductorone-sdk-go/pkg/models/operations\"\n\t\"log\"\n)\n\nfunc main() {\n    ctx := context.Background()\n\n    s := conductoronesdkgo.New(\n        conductoronesdkgo.WithSecurity(shared.Security{\n            BearerAuth: \"<YOUR_BEARER_TOKEN_HERE>\",\n            Oauth: \"<YOUR_OAUTH_HERE>\",\n        }),\n    )\n\n    res, err := s.Apps.List(ctx, operations.C1APIAppV1AppsListRequest{})\n    if err != nil {\n        log.Fatal(err)\n    }\n    if res.ListAppsResponse != nil {\n        // handle response\n    }\n}"
        - lang: typescript
          label: Typescript (SDK)
          source: >-
            import { ConductoroneSDKTypescript } from
            "conductorone-sdk-typescript";


            const conductoroneSDKTypescript = new ConductoroneSDKTypescript({
              security: {
                bearerAuth: "<YOUR_BEARER_TOKEN_HERE>",
                oauth: "<YOUR_OAUTH_HERE>",
              },
            });


            async function run() {
              const result = await conductoroneSDKTypescript.apps.list();

              console.log(result);
            }


            run();
components:
  schemas:
    c1.api.app.v1.ListAppsResponse:
      description: >-
        The ListAppsResponse message contains a list of results and a
        nextPageToken if applicable.
      properties:
        list:
          description: >-
            The list of results containing up to X results, where X is the page
            size defined in the request.
          items:
            $ref: '#/components/schemas/c1.api.app.v1.App'
          nullable: true
          readOnly: false
          type: array
        nextPageToken:
          description: >-
            The nextPageToken is shown for the next page if the number of
            results is larger than the max page size.
             The server returns one page of results and the nextPageToken until all results are retreived.
             To retrieve the next page, use the same request and append a pageToken field with the value of nextPageToken shown on the previous page.
          readOnly: false
          type: string
      title: List Apps Response
      type: object
      x-speakeasy-name-override: ListAppsResponse
    c1.api.app.v1.App:
      description: >-
        The App object provides all of the details for an app, as well as some
        configuration.
      properties:
        accessModel:
          description: >-
            How this app models access. Derived during uplift from the app's
            resource type traits.
             Sparse ACL feature.
          enum:
            - APP_ACCESS_MODEL_UNSPECIFIED
            - APP_ACCESS_MODEL_CLASSIC
            - APP_ACCESS_MODEL_HYBRID
            - APP_ACCESS_MODEL_SPARSE
          readOnly: false
          type: string
          x-speakeasy-unknown-values: allow
        appAccountId:
          description: The ID of the Account named by AccountName.
          readOnly: true
          type: string
        appAccountName:
          description: >-
            The AccountName of the app. For example, AWS is AccountID, Github is
            Org Name, and Okta is Okta Subdomain.
          readOnly: true
          type: string
        appOwners:
          description: The owners of the app.
          items:
            $ref: '#/components/schemas/c1.api.user.v1.User'
          nullable: true
          readOnly: true
          type: array
        appUserMapper:
          $ref: '#/components/schemas/c1.api.app.v1.AppUserMapper'
        certifyPolicyId:
          description: The ID of the Certify Policy associated with this App.
          readOnly: false
          type: string
        connectorVersion:
          description: The connectorVersion field.
          format: uint32
          readOnly: false
          type: integer
        createdAt:
          format: date-time
          readOnly: true
          type: string
        defaultRequestCatalogId:
          description: The ID for the default request catalog for this app.
          readOnly: false
          type: string
        deletedAt:
          format: date-time
          readOnly: true
          type: string
        description:
          description: The app's description.
          readOnly: false
          type: string
        displayName:
          description: The app's display name.
          readOnly: false
          type: string
        enableConnectorSourcedOwnership:
          description: When enabled, resource ownership is sourced from the connector.
          readOnly: false
          type: boolean
        fieldMask:
          nullable: true
          readOnly: true
          type: string
        grantPolicyId:
          description: The ID of the Grant Policy associated with this App.
          readOnly: false
          type: string
        iconUrl:
          description: The URL of an icon to display for the app.
          readOnly: false
          type: string
        id:
          description: The ID of the app.
          readOnly: true
          type: string
        identityMatching:
          description: The identityMatching field.
          enum:
            - APP_USER_IDENTITY_MATCHING_UNSPECIFIED
            - APP_USER_IDENTITY_MATCHING_STRICT
            - APP_USER_IDENTITY_MATCHING_DISPLAY_NAME
            - APP_USER_IDENTITY_MATCHING_CUSTOM
          readOnly: false
          type: string
          x-speakeasy-unknown-values: allow
        instructions:
          description: >-
            If you add instructions here, they will be shown to users in the
            access request form when requesting access for this app.
          readOnly: false
          type: string
        isDirectory:
          description: Specifies if the app is a directory.
          readOnly: true
          type: boolean
        isManuallyManaged:
          description: The isManuallyManaged field.
          readOnly: false
          type: boolean
        logoUri:
          description: The URL of a logo to display for the app.
          readOnly: true
          type: string
        monthlyCostUsd:
          description: >-
            The cost of an app per-seat, so that total cost can be calculated by
            the grant count.
          format: int32
          readOnly: false
          type: integer
        parentAppId:
          description: The ID of the app that created this app, if any.
          readOnly: true
          type: string
        revokePolicyId:
          description: The ID of the Revoke Policy associated with this App.
          readOnly: false
          type: string
        strictAccessEntitlementProvisioning:
          description: The strictAccessEntitlementProvisioning field.
          readOnly: false
          type: boolean
        updatedAt:
          format: date-time
          readOnly: true
          type: string
        userCount:
          description: The number of users with grants to this app.
          format: int64
          readOnly: true
          type: string
      title: App
      type: object
      x-speakeasy-entity: App
      x-speakeasy-name-override: App
    c1.api.user.v1.User:
      description: >-
        The User object provides all of the details for an user, as well as some
        configuration.
      properties:
        createdAt:
          format: date-time
          readOnly: true
          type: string
        delegatedUserId:
          description: >-
            The id of the user to whom tasks will be automatically reassigned
            to.
          readOnly: false
          type: string
        deletedAt:
          format: date-time
          readOnly: true
          type: string
        department:
          description: The department which the user belongs to in the organization.
          readOnly: true
          type: string
        departmentSources:
          description: >-
            A list of objects mapped based on department attribute mappings
            configured in the system.
          items:
            $ref: '#/components/schemas/c1.api.user.v1.UserAttributeMappingSource'
          nullable: true
          readOnly: true
          type: array
        directoryIds:
          description: A list of unique ids that represent different directories.
          items:
            type: string
          nullable: true
          readOnly: true
          type: array
        directoryStatus:
          description: The status of the user in the directory.
          enum:
            - UNKNOWN
            - ENABLED
            - DISABLED
            - DELETED
          readOnly: true
          type: string
          x-speakeasy-unknown-values: allow
        directoryStatusSources:
          description: >-
            A list of objects mapped based on directoryStatus attribute mappings
            configured in the system.
          items:
            $ref: '#/components/schemas/c1.api.user.v1.UserAttributeMappingSource'
          nullable: true
          readOnly: true
          type: array
        displayName:
          description: The display name of the user.
          readOnly: true
          type: string
        email:
          description: This is the user's email.
          readOnly: true
          type: string
        emailSources:
          description: A list of source data for the email attribute.
          items:
            $ref: '#/components/schemas/c1.api.user.v1.UserAttributeMappingSource'
          nullable: true
          readOnly: true
          type: array
        emails:
          description: This is a list of all of the user's emails from app users.
          items:
            type: string
          nullable: true
          readOnly: true
          type: array
        employeeIdSources:
          description: A list of source data for the employee IDs attribute.
          items:
            $ref: '#/components/schemas/c1.api.user.v1.UserAttributeMappingSource'
          nullable: true
          readOnly: true
          type: array
        employeeIds:
          description: This is a list of all of the user's employee IDs from app users.
          items:
            type: string
          nullable: true
          readOnly: true
          type: array
        employmentStatus:
          description: The users employment status.
          readOnly: true
          type: string
        employmentStatusSources:
          description: >-
            A list of objects mapped based on employmentStatus attribute
            mappings configured in the system.
          items:
            $ref: '#/components/schemas/c1.api.user.v1.UserAttributeMappingSource'
          nullable: true
          readOnly: true
          type: array
        employmentType:
          description: The employment type of the user.
          readOnly: true
          type: string
        employmentTypeSources:
          description: >-
            A list of objects mapped based on employmentType attribute mappings
            configured in the system.
          items:
            $ref: '#/components/schemas/c1.api.user.v1.UserAttributeMappingSource'
          nullable: true
          readOnly: true
          type: array
        id:
          description: A unique identifier of the user.
          readOnly: true
          type: string
        jobTitle:
          description: The job title of the user.
          readOnly: true
          type: string
        jobTitleSources:
          description: >-
            A list of objects mapped based on jobTitle attribute mappings
            configured in the system.
          items:
            $ref: '#/components/schemas/c1.api.user.v1.UserAttributeMappingSource'
          nullable: true
          readOnly: true
          type: array
        managerIds:
          description: A list of ids of the user's managers.
          items:
            type: string
          nullable: true
          readOnly: true
          type: array
        managerSources:
          description: >-
            A list of objects mapped based on managerId attribute mappings
            configured in the system.
          items:
            $ref: '#/components/schemas/c1.api.user.v1.UserAttributeMappingSource'
          nullable: true
          readOnly: true
          type: array
        origin:
          description: The origin of the user, describing who owns the user's lifecycle.
          enum:
            - USER_ORIGIN_UNSPECIFIED
            - USER_ORIGIN_DIRECTORY
            - USER_ORIGIN_LOCAL
            - USER_ORIGIN_SYSTEM
          readOnly: true
          type: string
          x-speakeasy-unknown-values: allow
        profile:
          additionalProperties: true
          readOnly: true
          type: object
        roleIds:
          description: >-
            A list of unique identifiers that maps to ConductorOne's user roles
            let you assign users permissions tailored to the work they do in the
            software.
          items:
            type: string
          nullable: true
          readOnly: false
          type: array
        status:
          description: The status of the user in the system.
          enum:
            - UNKNOWN
            - ENABLED
            - DISABLED
            - DELETED
          readOnly: false
          type: string
          x-speakeasy-unknown-values: allow
        type:
          description: The type of the user.
          enum:
            - USER_TYPE_UNSPECIFIED
            - USER_TYPE_SYSTEM
            - USER_TYPE_HUMAN
            - USER_TYPE_SERVICE
            - USER_TYPE_AGENT
          readOnly: true
          type: string
          x-speakeasy-unknown-values: allow
        updatedAt:
          format: date-time
          readOnly: true
          type: string
        username:
          description: >-
            This is the user's primary username. Typically sourced from the
            primary directory.
          readOnly: true
          type: string
        usernameSources:
          description: A list of source data for the usernames attribute.
          items:
            $ref: '#/components/schemas/c1.api.user.v1.UserAttributeMappingSource'
          nullable: true
          readOnly: true
          type: array
        usernames:
          description: This is a list of all of the user's usernames from app users.
          items:
            type: string
          nullable: true
          readOnly: true
          type: array
      title: User
      type: object
      x-speakeasy-name-override: User
    c1.api.app.v1.AppUserMapper:
      description: AppUserMapper configures custom account mapping for uplift.
      properties:
        mappingCases:
          description: >-
            Ordered list of match cases. Each case defines a pair of CEL key
            extractors.
          items:
            $ref: '#/components/schemas/c1.api.app.v1.AppUserMapperMatchCase'
          nullable: true
          readOnly: false
          type: array
      title: App User Mapper
      type: object
      x-speakeasy-name-override: AppUserMapper
    c1.api.user.v1.UserAttributeMappingSource:
      description: The UserAttributeMappingSource message.
      properties:
        appId:
          description: The appId field.
          readOnly: false
          type: string
        appUserId:
          description: The appUserId field.
          readOnly: false
          type: string
        appUserProfileAttributeKey:
          description: The appUserProfileAttributeKey field.
          readOnly: false
          type: string
        userAttributeMappingId:
          description: The userAttributeMappingId field.
          readOnly: false
          type: string
        value:
          description: The value field.
          readOnly: false
          type: string
      title: User Attribute Mapping Source
      type: object
      x-speakeasy-name-override: UserAttributeMappingSource
    c1.api.app.v1.AppUserMapperMatchCase:
      description: >-
        AppUserMapperMatchCase defines a single matching rule for uplift account
        mapping.
      properties:
        appUserKeyCel:
          description: CEL expression evaluated against an AppUser to produce match key(s).
          readOnly: false
          type: string
        userKeyCel:
          description: CEL expression evaluated against a User to produce match key(s).
          readOnly: false
          type: string
      title: App User Mapper Match Case
      type: object
      x-speakeasy-name-override: AppUserMapperMatchCase
  securitySchemes:
    bearerAuth:
      scheme: bearer
      type: http
    oauth:
      description: >-
        This API uses OAuth2 with the Client Credential flow.

        Client Credentials must be sent in the BODY, not the headers.

        For an example of how to implement this, refer to the
        [c1TokenSource.Token()](https://github.com/ConductorOne/conductorone-sdk-go/blob/3375fe7c0126d17e7ec4e711693dee7b791023aa/token_source.go#L101-L187)
        function.
      flows:
        clientCredentials:
          scopes: {}
          tokenUrl: /auth/v1/token
      type: oauth2

````